import pygtk
pygtk.require("2.0")

import unittest
import os
import shutil

import MetaData
import TrashFolderTree

class TrashFolderTests(unittest.TestCase):

    def setUp(self):
    	pass
	
    def tearDown(self):
    	pass

    def testCopyPhotos(self):
    	doc = MetaData.Document()
	photos = [MetaData.Photo()]
# XXX
	photos[0][u"imported-from"] = u"test-photos/IMG_2151.JPG"
	f = doc.storage.new_original(photos[0][u"id"])
	doc.storage.close_original(photos[0][u"id"], f)
	f = doc.storage.new_thumbnail(photos[0][u"id"])
	doc.storage.close_thumbnail(photos[0][u"id"], f)

    	tdoc = MetaData.Document()
    	t = TrashFolderTree.Model(tdoc)
	t.copy_photos(doc, photos)

    	deleted = t.photo_deletion_folder.photos.get()
	self.failUnless(len(deleted) == 1)
	self.failUnless(deleted[0] == photos[0])
	
	self.failUnless(doc.storage.get_original_filename(photos[0][u"id"]))
	self.failUnless(tdoc.storage.get_original_filename(deleted[0][u"id"]))
	
	self.failUnless(doc.storage.get_thumbnail_filename(photos[0][u"id"]))
	self.failUnless(tdoc.storage.get_thumbnail_filename(deleted[0][u"id"]))
	
    	doc.storage.discard()
	tdoc.storage.discard()
